
         ADC_HandleTypeDef                 hadc1;          
         DMA_HandleTypeDef             hdma_adc1;

#define  BUF_SIZE               ((uint32_t)  256)   
        
         uint16_t     buff[BUF_SIZE]    =   { 0};
         
         String       in_String         =     "";        
         boolean      end_input         =  false;  
         uint32_t     adres_reg     = 0x4000042c;         
         uint8_t      debug_osm         =      0;

         uint32_t     adres_bas         =      0;         
         uint32_t     field_bit         =      0;
         uint32_t     field_len         =     16;

volatile uint32_t     temp;
         uint32_t     addr;


void setup()
{
  Serial.begin(115200);
  in_String.reserve(200);

  //  SystemClock_Config();

  Serial.print("\n\tGPIO.");  
  delay(100);      
  cfgPin(); // debug
  Serial.print("\t complete.");  
  delay(100);      

  //  ADC_DeInit();
  
  hadc1.Instance = ADC1;    
  Serial.print("\n\tDMA.");  
  delay(100);      
  Dma_Init1( &hadc1 );
  Serial.print("\t complete.");  
  delay(100);      
  
  Serial.print("\n\tADC.");  
  delay(100);      
  Adc_Cfg1();
  Serial.print("\t complete.");  
  delay(100);      
  
  //  __HAL_DMA_DISABLE_IT(DacHandle.DMA_Handle1, DMA_IT_HT);
  //  HAL_ADCEx_MultiModeStart_DMA(&AdcHandle1, (uint32_t *)adc_in1, BUF_SIZE);

  HAL_ADC_Start_DMA(&hadc1, (uint32_t *)buff, BUF_SIZE);
  
  Serial.print("\n\tTIM3.");  
  delay(100);      
  TIM3_Config();
  Serial.print("\t complete.");  
  delay(100);      
}

void loop()
{
  uint32_t  temp = 0;
  char *   pEnd;
  
  if(debug_osm) {
    }

// d, a, r, w
// b - adres + base
// f, s - bit field, size
// o -offset Tim-2 & Tim-4

  serialEvent(); 

  if( end_input) {
    char cmd = in_String[0];
    in_String[0] = '+';
    
    if( cmd == 'd' ) {
      debug_osm = 1 - debug_osm;
      if(debug_osm) Serial.print(F("\nDebug aktiv."));
      else          Serial.print(F("\nDebug de-aktiv."));
      }

    // "x" command - print a table of incomming buffer.
    if( cmd == 'x' ) {
      TIM3->CR1 &= ~(TIM_CR1_CEN);
      Serial.print("\n\t");  
        for( uint16_t i = 0; i < BUF_SIZE; i++) {  
          uint16_t tempr = buff[i];  
            Serial.print(tempr, DEC);       
            Serial.print("\t");    
            if ((i+1)%16 == 0) Serial.print("\n\t");
            }

      Serial.print("\n\t");  
        uint32_t ac1 = 0, ac2 = 0;
        for( uint16_t i = 0; i < BUF_SIZE; ) {  
          ac1 += buff[i++];  
          ac2 += buff[i++];  
          }
         ac1 >>= 7; 
         ac2 >>= 7; 
         Serial.print(ac1, DEC);       
         Serial.print("\t");    
         Serial.print(ac2, DEC);       
            
      TIM3->CR1 |=  (TIM_CR1_CEN);
      }
/*      
    if ( cmd == 'o' ) {
      offset_tt = strtol( in_String.c_str(), &pEnd, 10);
      Serial.print(F("\n\tTT offset: "));
      Serial.print(offset_tt, DEC);
      delay(200);
      
      TIM3->CR1 &= ~(TIM_CR1_CEN);

            addr = 0x40000024;
      (*(uint32_t*)addr) =         0; // reset cntr tim-2

            addr = 0x40000824;
      (*(uint32_t*)addr) = offset_tt; // pre-set cntr tim-4
            
      TIM3->CR1 |=  (TIM_CR1_CEN);
    }
*/
    if ( cmd == 'f' ) {
      field_bit = strtol( in_String.c_str(), &pEnd, 10);
      if(field_bit < 32) {
        Serial.print(F("\n\tBit field starts: "));
        Serial.print(field_bit, DEC);        
        }
      else
        Serial.print(F("\n\tError."));
    }
    if ( cmd == 's' ) {
      field_len = strtol( in_String.c_str(), &pEnd, 10);
      if((field_len + field_bit) < 32) {
        Serial.print(F("\n\tBit field length: "));
        Serial.print(field_len, DEC);        
        }
      else
        Serial.print(F("\n\tError."));
    }
        
    if( cmd == 'b' ) {
      adres_bas = strtol( in_String.c_str(), &pEnd, 16);
      adres_reg &= 0xFFFFFF00;
      adres_reg |= adres_bas;
      Serial.print(F("\n\tReg: "));
      Serial.print(adres_reg, HEX);
      Serial.print(F("\tValue: "));
      temp =   (*(uint32_t*)adres_reg);
      prnt_binf(temp);
      }

    if( cmd == 'a' ) {
      adres_reg = strtol( in_String.c_str(), &pEnd, 16);
      Serial.print(F("\n\tReg: "));
      Serial.print(adres_reg, HEX);
      Serial.print(F("\tValue: "));
      temp =   (*(uint32_t*)adres_reg);
      prnt_binf(temp);
      }
    if( cmd == 'r' ) {
      Serial.print(F("\n\tReg: "));
      Serial.print(adres_reg, HEX);
      Serial.print(F("\tValue: "));
      temp =   (*(uint32_t*)adres_reg);
      prnt_binf(temp);
      }
    if( cmd == 'w' ) {
      Serial.print(F("\n\tReg: "));
      Serial.print(adres_reg, HEX);
      Serial.print(F("\tValue: "));
      temp =   (*(uint32_t*)adres_reg);
      prnt_binf(temp);
      
      temp = strtol( in_String.c_str(), &pEnd, 2);      
//      (*(uint32_t*)adres_reg) = temp;
      set_bitf(temp);
  
      Serial.print(F("\tnew Value: "));
      temp =   (*(uint32_t*)adres_reg);
      prnt_binf(temp);
      }
                
    in_String = "";
    end_input= false;
  }
}

void serialEvent() {
  while (Serial.available()) {
    char inChar = (char)Serial.read();
    in_String += inChar;
    if (inChar == '\n') {
      end_input= true;
    }
  }
}
