#define ADC_CALIBRATION_TIMEOUT         ( 10U)
#define ADC_ENABLE_TIMEOUT              (  2U)
#define ADC_DISABLE_TIMEOUT             (  2U)
#define ADC_STOP_CONVERSION_TIMEOUT     ( 11U)
//#define ADC_STAB_DELAY_US               ( 10U)


void ADC_Init4(ADC_HandleTypeDef* hadc)
{
  ADC_Common_TypeDef *tmpADC_Common;
  
  Serial.print("\n\t21.");  
  delay(100);      
  tmpADC_Common = ADC_COMMON_REGISTER(hadc);
  
  tmpADC_Common->CCR &= ~(ADC_CCR_ADCPRE);
  tmpADC_Common->CCR |=  hadc->Init.ClockPrescaler;
  
  hadc->Instance->CR1 &= ~(ADC_CR1_SCAN);
  hadc->Instance->CR1 |=  ADC_CR1_SCANCONV(hadc->Init.ScanConvMode);
  
  hadc->Instance->CR1 &= ~(ADC_CR1_RES);
  hadc->Instance->CR1 |=  hadc->Init.Resolution;
  
  hadc->Instance->CR2 &= ~(ADC_CR2_ALIGN);
  hadc->Instance->CR2 |= hadc->Init.DataAlign;
  
  Serial.print("\t22.");  
  delay(100);      
  if(hadc->Init.ExternalTrigConv != ADC_SOFTWARE_START)
  {
    Serial.print("\t23.");  
    delay(100);      
    hadc->Instance->CR2 &= ~(ADC_CR2_EXTSEL);
    hadc->Instance->CR2 |= hadc->Init.ExternalTrigConv;
    
    hadc->Instance->CR2 &= ~(ADC_CR2_EXTEN);
    hadc->Instance->CR2 |= hadc->Init.ExternalTrigConvEdge;
  }
  else
  {
    Serial.print("\t24.");  
    delay(100);      
    hadc->Instance->CR2 &= ~(ADC_CR2_EXTSEL);
    hadc->Instance->CR2 &= ~(ADC_CR2_EXTEN);
  }
  
  Serial.print("\t25.");  
  delay(100);      
  hadc->Instance->CR2 &= ~(ADC_CR2_CONT);
  hadc->Instance->CR2 |= ADC_CR2_CONTINUOUS(hadc->Init.ContinuousConvMode);
  
  Serial.print("\t26.");  
  delay(100);      
  if(hadc->Init.DiscontinuousConvMode != DISABLE)
  {
    Serial.print("\t27.");  
    delay(100);      
    assert_param(IS_ADC_REGULAR_DISC_NUMBER(hadc->Init.NbrOfDiscConversion));
  
    hadc->Instance->CR1 |= (uint32_t)ADC_CR1_DISCEN;
    
    hadc->Instance->CR1 &= ~(ADC_CR1_DISCNUM);
    hadc->Instance->CR1 |=  ADC_CR1_DISCONTINUOUS(hadc->Init.NbrOfDiscConversion);
    Serial.print("\t28.");  
    delay(100);      
  }
  else
  {
    Serial.print("\t29.");  
    delay(100);      
    hadc->Instance->CR1 &= ~(ADC_CR1_DISCEN);
  }
  
  Serial.print("\t30.");  
  delay(100);      
  hadc->Instance->SQR1 &= ~(ADC_SQR1_L);
  hadc->Instance->SQR1 |=  ADC_SQR1(hadc->Init.NbrOfConversion);
  
  hadc->Instance->CR2 &= ~(ADC_CR2_DDS);
  hadc->Instance->CR2 |= ADC_CR2_DMAContReq(hadc->Init.DMAContinuousRequests);
  
  hadc->Instance->CR2 &= ~(ADC_CR2_EOCS);
  hadc->Instance->CR2 |= ADC_CR2_EOCSelection(hadc->Init.EOCSelection);
  Serial.print("\t32.\n");  
  delay(100);      
}

HAL_StatusTypeDef my_ADC_Init4(ADC_HandleTypeDef* hadc)
{
  HAL_StatusTypeDef tmp_hal_status = HAL_OK;
  
  if(hadc == NULL)
  {
    return HAL_ERROR;
  }
  
  Serial.print("\t1.");  
  delay(100);      
  assert_param(IS_ADC_ALL_INSTANCE(hadc->Instance));
  assert_param(IS_ADC_CLOCKPRESCALER(hadc->Init.ClockPrescaler));
  assert_param(IS_ADC_RESOLUTION(hadc->Init.Resolution));
  assert_param(IS_FUNCTIONAL_STATE(hadc->Init.ScanConvMode));
  assert_param(IS_FUNCTIONAL_STATE(hadc->Init.ContinuousConvMode));
  assert_param(IS_ADC_EXT_TRIG(hadc->Init.ExternalTrigConv));
  assert_param(IS_ADC_DATA_ALIGN(hadc->Init.DataAlign));
  assert_param(IS_ADC_REGULAR_LENGTH(hadc->Init.NbrOfConversion));
  assert_param(IS_FUNCTIONAL_STATE(hadc->Init.DMAContinuousRequests));
  assert_param(IS_ADC_EOCSelection(hadc->Init.EOCSelection));
  assert_param(IS_FUNCTIONAL_STATE(hadc->Init.DiscontinuousConvMode));
  
  Serial.print("\t2.");  
  delay(100);      
  if(hadc->Init.ExternalTrigConv != ADC_SOFTWARE_START)
  {
    Serial.print("\t3.");  
    delay(100);      
    assert_param(IS_ADC_EXT_TRIG_EDGE(hadc->Init.ExternalTrigConvEdge));
  }
  
  Serial.print("\t4.");  
  delay(100);      
  if(hadc->State == HAL_ADC_STATE_RESET)
  {
    Serial.print("\t5.");  
    delay(100);      
    ADC_CLEAR_ERRORCODE(hadc);
    
    hadc->Lock = HAL_UNLOCKED;
    Serial.print("\t6.");  
    delay(100);      
    
//    HAL_ADC_MspInit(hadc);
  }
  
  Serial.print("\t8.");  
  delay(100);      
  if (HAL_IS_BIT_CLR(hadc->State, HAL_ADC_STATE_ERROR_INTERNAL))
  {
    Serial.print("\t9.");  
    delay(100);      
    ADC_STATE_CLR_SET(hadc->State,
                      HAL_ADC_STATE_REG_BUSY | HAL_ADC_STATE_INJ_BUSY,
                      HAL_ADC_STATE_BUSY_INTERNAL);
    
    Serial.print("\t10.");  
    delay(100);      
    ADC_Init4(hadc);
    Serial.print("\t11.");  
    delay(100);      
    
    ADC_CLEAR_ERRORCODE(hadc);
    
    ADC_STATE_CLR_SET(hadc->State,
                      HAL_ADC_STATE_BUSY_INTERNAL,
                      HAL_ADC_STATE_READY);
    Serial.print("\t12.");  
    delay(100);      
  }
  else
  {
    Serial.print("\t14.");  
    delay(100);      
    tmp_hal_status = HAL_ERROR;
  }
  
  Serial.print("\t15.");  
  delay(100);      
  __HAL_UNLOCK(hadc);

  return tmp_hal_status;
}
